#!/bin/sh
#\
exec stash $0 $@

# last edition 07-01-2005

load_package gap

# ---------------------------------------------------
set DbSpec  [lindex $argv 0]
set TgtChar [lindex $argv 1]

if {[set dot [string last . $DbSpec]] == -1} {
  puts stderr "ERROR: invalid database name '$argv'"
  exit 1
}

# DB file should exist
if {! [file exists $DbSpec]} {
  puts stderr "ERROR: specified database '$argv' doesn't exist"
  exit 1
}

set dbname [string range $DbSpec 0 [expr $dot-1]]
set dbvers [string range $DbSpec [expr $dot+1] end]


if {[string length $TgtChar] != 1} {
  puts stderr "ERROR: arg2 must be single letter (= version suffix)"
  exit 1
}

# ---------------------------------------------------

set io [open_db -name $dbname -version $dbvers -access r]

copy_db             \
  -io      $io      \
  -version $TgtChar \
  -collect 1


# close the database
close_db -io $io
exit 
