#!/bin/sh
#\
exec stash $0 $@

# last edition 05-01-2005

#catch {tkinit}
#load_package tk_utils
#tk_utils_init
load_package gap
source /my/modules/directory/GenALA/bin/gap4.inc

set consensus_mode   2  
set consensus_cutoff 0.01
set quality_cutoff   -1


# ---------------------------------------------------

if {[set dot [string last . $argv]] == -1} {
  puts stderr "ERROR: invalid database name '$argv'"
  exit 1
}

set dbname [string range $argv 0 [expr $dot-1]]
set dbvers [string range $argv [expr $dot+1] end]

# DB file should exist
if {! [file exists $argv]} {
  puts stderr "ERROR: specified database '$argv' doesn't exist"
  exit 1
}

# ---------------------------------------------------

set io [open_db -name $dbname -version $dbvers -access r]
set maxseq [expr round ([db_info t_contig_length $io] * 1.2) ]
set ListContig [CreateAllContigList $io]

get_consensus 		   \
  -io $io			   \
  -outfile tmp.cons    \
  -contigs $ListContig \
  -format 3            \
  -strip_pads 0 	   \
  -annotations 1	   \
  -truncate 1		   \
  -mask mask

# close the database
close_db -io $io
exit 
