#!/bin/sh
#\
exec stash $0 $@

# last edition 19-01-2005

load_package gap

# ---------------------------------------------------

if {[set dot [string last . $argv]] == -1} {
  puts stderr "ERROR: invalid database name '$argv'"
  exit 1
}
set dbname [string range $argv 0 [expr $dot-1]]
set dbvers [string range $argv [expr $dot+1] end]

# DB file should exist
if {! [file exists $argv]} {
  puts stderr "ERROR: specified database '$argv' doesn't exist"
  exit 1
}

# ---------------------------------------------------

set io [open_db -name $dbname -version $dbvers -access r]
set maxseq [expr round ([db_info t_contig_length $io] * 1.2) ]
set ListContig [CreateAllContigList $io]

# print to STDOUT automatically
show_relationships     \
  -io $io			   \
  -contigs $ListContig

# close the database
close_db -io $io
exit 
