package Contigbridges;

use strict;

use vars qw (@EXPORT @ISA);
use Exporter;
@ISA    = qw (Exporter);
@EXPORT = qw (&contigbridges);



# Calculation of clone bridges

sub contigbridges {
	my( $pBridgeclone, $pRead, $pContig, $pClone, $pEndread, $opt ) = @_;
	my( $item, $read, $size, $run, $number, $id );
	my( %bridge, %bridgenumber, %bridgelength );
	my( @bridgenumber, @bridgelength, @contigs );

	%bridge       = ();
	%bridgenumber = ();
	%bridgelength = ();
	@bridgenumber = ();
	@bridgelength = ();

print "\t\tCalculating Contig Brigdes\n\n";
	if( $opt ){
		foreach $item ( keys %$pBridgeclone ){
			@contigs = ();

			if( $#{$$pClone{$item}{runs}} == 1 ){
				foreach $run( @{$$pClone{$item}{runs}} ){
					$read = join '.', $item, $run;
					push( @contigs, $$pRead{$read}{contig}{id} );
				}
	
				if ( exists $bridge{$contigs[0]."_".$contigs[1]} ){
					push ( @{$bridge{$contigs[0]."_".$contigs[1]}{clone}}, $item );
				}
				elsif( exists $bridge{$contigs[1]."_".$contigs[0]} ){
					push ( @{$bridge{$contigs[1]."_".$contigs[0]}{clone}}, $item );
				}
				else{
					$size = $$pContig{$contigs[0]}{length} + $$pContig{$contigs[1]}{length};
					$id = $contigs[0]."_".$contigs[1];

					$bridge{$id} = {
						bridge  => $id,
						seq     => "",
						l_seq1  => "",
						l_seq2  => "",
						contig1 => $contigs[0],
						contig2 => $contigs[1],
						size    => $size,
						clone   => [$item],
						length  => "",
					};
				}
			}
		}
	}
	return ( \%bridge );
}

1;
