################################################################################
#
#  all rights reserved
#  Karol Szafranski at IMB Jena, Dept. Genome Analysis, 2001-2002,2004
#  szafrans@imb-jena.de
#
################################################################################

package DefaultObjArray;

# includes
use strict;
use DefaultObj;

# inheritance
our @ISA;
push @ISA, qw(DefaultObj);


# return class instance
#
# INTERFACE
# - argument 1*: initialisation arguments
# - return val:  reference on object
#
# DESCRIPTION
# - see class function for detailed description of initialisation parameter
#   convention.
# - this function will call method ini() in the derived class
#
sub new {
  my $this = [];
  my ($class, @arg) = @_;

  bless $this, ref($class) || $class;
  return $this->ini(@arg);
}


1;
