# >>>>>>>>>>>>>>>>>>>>>>>>> mbs Defaults file <<<<<<<<<<<<<<<<

package Defaults;

require Exporter;

@ISA    =   qw (Exporter);
@EXPORT =   qw ($default_version $Identifiers %SeqTypes
                $Alphabet $standard_prog_path
                $ERR_no_tripl_message $ERR_no_start_message
                $ERR_no_stop_message $ERR_stop_in_message
               );


$default_version     =  '2.24';                  # this here

# >>>>>>>>>>>>>>>>>>>>>>>  Paths  <<<<<<<<<<<<<<<<<<<<<<<

# path to GenALA
$standard_prog_path   =  '/my/modules/directory/';

# >>>>>>>>>>>>>>>>>>>>>>>  constants  <<<<<<<<<<<<<<<<<<<<<<<

%SeqTypes = ( 'all'       => 'ABCDEFGHIKLMNPQRSTUVWXY-*',
              'nt-IUPAC'  => 'ACGTUBDHKMNRSVWY',
              'nt-ambig'  => 'BDHKMNRSVWY',
              'DNA_N'     => 'ACGTN',
              'DNA'       => 'ACGT',
              'RNA'       => 'ACGU',
              'nt'        => 'ACGTU',
              'nt_N'      => 'ACGTUN',
              'prot'      => 'ACDEFGHIKLMNPQRSTVWY',
              'prot_X'    => 'ACDEFGHIKLMNPQRSTVWYX',
            );

$Alphabet    = 'abcdefghijklmnopqrstuvwxyz';
$Identifiers = '0123456789abcdefghijklmnopqrstuvwxyz';
$ERR_no_tripl_message = 'CDS is not devisible into triplets!';
$ERR_no_start_message = 'Has no start codon!';
$ERR_no_stop_message  = 'Has no stop codon!';
$ERR_stop_in_message  = 'Stop codon inside CDS!';


1;
