# Aufruf durch gap2primer; bbgap2genbank

# INPUT: Projektname

# OUTPUT: 3 Hashes + 1 Array
 
# 1. Contiglaenge mit Contigname als Index
#	 %contiglength = ( $contigname => contiglaenge )
#
# 2. Readnamen mit ihren Eigenschaften: Teil von ContigX, Position, Laenge(orientiert)
#	 %read = (
#	 			 contig   => contignr,
#	 			 position => 301,
#	 			 length   => -523,
#	 		   );
#
# 3. Array mit den Contignamen
#
# 4. Hash mit den Listen der "Runs" pro Clone


package GapRelation;

use strict;

use vars qw (@EXPORT @ISA);
use Exporter;
@ISA    = qw (Exporter);
@EXPORT = qw ( &gaprelation );





sub gaprelation {
	my ( $project, $dir, $pClonelimit, $pContiglimit) = @_;
	my ( %read, %contig, %clone, %end_reads, $pCurrCtg, $probability );
	my ( $line, $newcontig, $contigname, $contiglength, $read, $run );
	my ( @clone, $clone, $pos, $length, $bank, %begin_reads, $i, $test );
	my ( $contignumber, $id );
	
	
    open ( README, "$dir/showrelationships.sh $project |" ) || die "Cannot open $project file!\n";

	print "\n\n\t\tread showrelationship of $project\n\n";
	$newcontig = 0;

	%contig       = ();
	%read         = ();
	%clone        = ();
	
	while( <README> ){

# It is necessary that the nomenclature of read names is structured in:
# <Clone bank name> <plate number> <plate coordinate>.<run>

#Bsp:G1a25a03.r1                                      1        1  -715        0        2
		if( /^(\S+)\s+\d+\s+(\d+)\s+(-*\d+)\s+\d+\s+\d+\n/ && $contiglength > $pContiglimit ){
			if( $newcontig ){
				$pCurrCtg = $contig{$1} = {
					id     => $1,
					length => $contiglength,
					number => $contignumber,
				};

				$newcontig = 0;
			}

			$read{$1} = {
				contig   => $pCurrCtg,
				position => $2,
				length   => $3,
			};

			push @{$read{$1}{contig}{$2}{read}}, $1;

			@clone = split( /\./, $1 );
			if( $#clone > 0 ){
				$run   = pop( @clone );
				$clone = join( "", @clone );
				push( @{$clone{$clone}{runs}}, $run );
				$clone{$clone}{length} = 0;
				$clone{$clone}{limit}  = 0;

#------ clone status describes the reliability of clone information ------------
#-------------- ( chimeric, wrong length, wrong assembly, ... ) ----------------
#------------------- ( -1 = bad; 0 = undefined; 1 = true ) ---------------------
				$clone{$clone}{status} = 0;
			}
		}	
		elsif( /^ CONTIG LINES/ ){
			$newcontig   = 1;
			%end_reads   = ();
		}

#Bsp:                        1   916934               1     4750\n
		elsif( /^\s+\d+\s+(\d+)\s+(\d+)\s+\d+\n/ ){
			$contiglength = $1;
			$contignumber = $2;
		}
	}
	close( README );

	return ( \%read, \%contig, \%clone, \%end_reads );
}

1;
