package Hash2Fasta;

use strict;

use vars qw (@EXPORT @ISA);
use Exporter;
@ISA    = qw (Exporter);
@EXPORT = qw ( &hash2fasta );



sub hash2fasta{
	my( $pContig, $fasta ) = @_;
	
	my( $seq_origin, $item, $seq, @seq, $target, $i, $j, $k, $l, $pads, $seqlength );
	
	open( OUT, ">$fasta" );
print "fasta\t$fasta \n";

# =========================   Backbone o. Target   ============================
	#$seq_origin = ( $fasta =~ /backbone/ ) ? "bbsequence" : "sequence";
	#$pads       = ( $fasta =~ /p.fa/ ) ? 1 : 0;

	$seq_origin = ( $fasta =~ m/_r\.fa/ ) ? "bbsequence" : "sequence"; #mf
	$pads       = ( $fasta =~ m/p\.fa/ ) ? 1 : 0; #mf

# ===================   Fasta-Seq mit Pads o. Backbone-Fasta   ================
	#if ( $fasta =~ /p.fa/ || $seq_origin eq "bbsequence" ){	# ( 3 ), ( 5 ) & ( 6 )
	if ( $fasta =~ m/p\.fa/ || $seq_origin eq "bbsequence" ){	# ( 3 ), ( 5 ) & ( 6 ) #mf
print STDERR "Hash2Fasta.pm: Fasta-Seq mit Pads o. Backbone-Fasta: $fasta\n\n"; #mf
		foreach $item ( keys %$pContig ){
			printf OUT ">$item\n";
			@seq = @{$$pContig{$item}{$seq_origin}};

			if( $seq_origin eq "sequence" ){
				
			        for( $i = 0; $i <= $#seq; $i++ ){

					if ( $$pContig{$item}{coverage}[$i] == 0 ){
						$seq[$i] = "*";
					}
				}
			}	
#			$seq =~ s/\*//g if ( $fasta =~ /_s.fa/ && $seq_origin eq "bbsequence" );
			$seq = join "", @seq;
			fastaprint( $seq, $pads );
		}



# =====   Target-Fasta-Seq mit Backbone-Anteil als Kleinbuchstabe o. 'n'   ====
	#} elsif( $fasta =~ /_[hn].fa/ ){							# ( 1 ) & ( 2 )
	} elsif( $fasta =~ /_[hn]\.fa/ ){ #mf							# ( 1 ) & ( 2 )
print STDERR "Hash2Fasta.pm: Target-Fasta-Seq mit Backbone-Anteil: $fasta\n\n"; #mf		
		foreach $item ( keys %$pContig ){
			printf OUT ">$item\n";
			@seq = @{$$pContig{$item}{$seq_origin}};
			
			for( $i = 0; $i <= $#seq; $i++ ){

				if ( $$pContig{$item}{coverage}[$i] == 0 ){
					$seq[$i] = ( $fasta =~ /_n.fa/ ) ? "n" : lc( $$pContig{$item}{bbsequence}[$i] );
				}
			}
			$seq = join "", @seq;
			$seq =~ s/\*//g;
			fastaprint( $seq, $pads );

			if( $fasta !~ /_n.fa/ ){
				$$pContig{$item}{hybrid} = "";
				$seqlength = length( $seq );
				$l = 0;
				
				while( $l < $seqlength-1 ){
					$k++;
					
					if( $k == 1 ){
						$$pContig{$item}{hybrid} .= sprintf "     ";
					}
					
					if( $k == 6 ){
						$$pContig{$item}{hybrid} .= sprintf "%s\n", substr($seq, $l, 10);
						$k = 0;
					} else {
						$$pContig{$item}{hybrid} .= sprintf "%s ", substr($seq, $l, 10);
					}
					
					$l += 10;
				}
				$$pContig{$item}{hybrid} .= sprintf "\n" if ($k != 0);
			}
		}
		


# =====================   Target-Fasta-Seq ohne Pads   ========================
	#} elsif( $fasta =~ /_[rt].fa/ ){ 								# ( 4 )
	} elsif( $fasta =~ /_t\.fa/ ){ #mf								# ( 4 )
print STDERR "Hash2Fasta.pm: Target-Fasta-Seq ohne Pads: $fasta\n\n"; #mf
		foreach $item ( keys %$pContig ){
			$target = 0;
			$j      = 1;
			@seq    = ();
			
			while( $j <= $#{$$pContig{$item}{coverage}}+1 ){
				
				if( $$pContig{$item}{coverage}[$j-1] > 0 ){
					if( $target == 0 ){
# --------------   Hier knnte auch ein Backbone-Name stehen   ----------------
print  "$item\t$j\n";
						print OUT ">$$pContig{$item}{$j}{read}[0]\n";
					}
					push @seq, $$pContig{$item}{sequence}[$j-1];
					$target = 1;
				}

				if( $$pContig{$item}{coverage}[$j-1] == 0 || $j == $#{$$pContig{$item}{coverage}}+1 ){
					if( $target == 1 ){
						$seq = join "", @seq;
						fastaprint( $seq, $pads );
#						fastaprint( $seq, $pads, *OUT );
						@seq = ();
					}
					$target = 0;
				}
				$j++;
			}
		}


# ===============================   FEHLER   ==================================
	} else {
		print "\n\n\t\tFEHLER!\n\n";
		exit 1;
	}
	close( OUT );
}




sub fastaprint{

	my( $seq_, $s ) = @_;

	my( $l, $i, $string );

	$seq_ =~ s/\*//g unless( $s );
	$l    = length( $seq_ );
	
	for ( $i = 0; $i < $l; $i+=60){
		$string    = substr($seq_, $i, 60);
		print OUT "$string\n";
	}

}



1;

