package JoinBridges;

use strict;

use vars qw (@EXPORT @ISA);
use Exporter;
@ISA    = qw (Exporter);
@EXPORT = qw (&joinbridges);





sub joinbridges {
	my ( $pBridge, $pRead, $pContig, $pClone, $pEndreads, $opt ) = @_;
	my ( $dummy, $read1, $read2, $seq1, $seq2, $item, $clone, $revseq, $size );
	my ( $contig1, $contig2 );
	
	$size  = 1000;
	$dummy = 'N' x 1000;

	print "\n\tWriting Bridges\n";
	
	foreach $item ( keys %$pBridge ){

		$clone = ${$pBridge->{$item}{clone}}[0];
		$read1 = join '.', $clone, $$pClone{$clone}{runs}[0];
		$read2 = join '.', $clone, $$pClone{$clone}{runs}[1];

		$contig1 = $$pRead{$read1}{contig}{id};
		$contig2 = $$pRead{$read2}{contig}{id};


		$seq1 = join '', @{$$pContig{$contig1}{sequence}};
		$seq1 =~ s/\*//g;
		$seq2 = join '', @{$$pContig{$contig2}{sequence}};
		$seq2 =~ s/\*//g;

		if( ( $$pRead{$read1}{length} > 0 && $$pRead{$read2}{length} < 0 ) or ( $$pRead{$read1}{length} < 0 && $$pRead{$read2}{length} > 0 ) ){

			if ( $$pRead{$read1}{length} > 0 ){

				getsequence( $pBridge, "l_seq1", $seq1, $item, $size, -1 );
				$$pBridge{$item}{seq}   .= $dummy;
				getsequence( $pBridge, "l_seq2", $seq2, $item, $size, 0 );

				
			}else{

				getsequence( $pBridge, "l_seq1", $seq2, $item, $size, -1 );
				$$pBridge{$item}{seq}   .= $dummy;
				getsequence( $pBridge, "l_seq2", $seq1, $item, $size, 0 );

			}
		}else{
			
			if ( $$pRead{$read1}{length} > 0 ){

				$revseq = reverse( $seq2 );
				$revseq =~ tr/ACGTacgt/TGCAtgca/;
				getsequence( $pBridge, "l_seq1", $seq1, $item, $size, -1 );
				$$pBridge{$item}{seq}   .= $dummy;
				getsequence( $pBridge, "l_seq2", $revseq, $item, $size, 0 );

			}else{

				$revseq = reverse( $seq1 );
				$revseq =~ tr/ACGTacgt/TGCAtgca/;
				getsequence( $pBridge, "l_seq1", $revseq, $item, $size, -1 );
				$$pBridge{$item}{seq}   .= $dummy;
				getsequence( $pBridge, "l_seq2", $seq2, $item, $size, 0 );

			}
		}
	}
	

################################################################################
# 
################################################################################

my ( $id, $length, @seq, $max );

	if ( $opt ){

		foreach $item ( keys %$pContig ){
		
			$id = $item;
		
			if( $#{$$pContig{$item}{sequence}} > -1 ){

				if( $$pContig{$item}{length} >= 1000 ){
					$max    = $#{$$pContig{$item}{sequence}};
					$length = 1000;
			 		$seq1   = join '', @{$pContig->{$item}{sequence}}[0..999];			   
					$seq1   =~ s/\*//g;
					$seq2   = join '', @{$pContig->{$item}{sequence}}[($max-999)..$max]; 
					$seq2   =~ s/\*//g;
				}else{
					$length = $pContig->{$item}{length};
					$seq1   = join '', @{$pContig->{$item}{sequence}};			    
					$seq1   =~ s/\*//g;
					$seq2   = $seq1; 
				}
					
			
				$$pBridge{$id} = {											 	 
					bridge  => $id, 										 	 
					seq     => sprintf ("%s%s%s", $seq2, $dummy, $seq1),
					l_seq1  => $length,										 	 
					l_seq2  => $length,										 	 
					contig1 => $item,										 	 
					contig2 => $item,										 	 
					size    => 0,   									 	 
					clone   => [],
					length  => $$pContig{$item}{length},
				};
			}
		}
	}
}

sub getsequence{
	my ( $pB, $index, $seq, $i, $s, $f ) = @_;
	
	if ( length( $seq ) > $s ){
		$$pB{$i}{seq}   .= substr $seq, ($s * $f), $s;
		$$pB{$i}{$index} = 1000;
	}else{
		$$pB{$i}{seq}   .= $seq;
		$$pB{$i}{$index} = length( $seq );
	}
	
}

1;



