package Un_Padded_Fasta;

use strict;

use vars qw (@EXPORT @ISA);
use Exporter;
@ISA    = qw (Exporter);
@EXPORT = qw (&un_padded_fasta);


# last edition 05-01-2005


my $VERSION = 2.1;


###############################################################################

sub un_padded_fasta{

	my( $project, $pFasta, $pFasta_pads, $Contiglimit, $padded, $unpadded, $dir ) = @_;
	my( $fasta_length, $id, $pads_length, $seq );
	my( $seq_f, $seq_p, $tmp );
	my( %fasta, %fasta_pads );
	my( @project, @seq );



# ------------------------- writing consensus of project -----------------------

	$tmp = "tmp.cons";

	print "\n\tExport Consensus of $project\n";

	system ( "$dir/exportconsensus.sh $project" );

	open( TMP, $tmp ) || die "Cannot open $tmp file!\n";

	print "\n\tReading of Contigs\n";

	while( <TMP> ){
		chomp;
#================================= SWITCH =====================================
		SWITCH:{
			if( !/^\s+(.+)|^ID   (.+)|\/\// ){ last SWITCH; }

			if( /^\s+(.+)/ ){
				( $seq = $1 ) =~ s/ //g;
				push( @seq, $seq );
				last SWITCH; 
			}

			if( /^ID   (.+)/ ){
				@seq = "";
				$id = $1;
				last SWITCH; 
			}

			if( /\/\// ){
				$seq = join "", @seq;
			
				$seq   =~ s/-/N/g;
				$seq_p = $seq;

				( $seq_f = $seq ) =~ s/\*//g;
			
				$fasta_length = length( $seq_f );
				$pads_length  = length( $seq_p ); 
			
				if( $fasta_length > $Contiglimit ){

					$$pFasta_pads{$id} = $seq_p;
					$$pFasta{$id}      = $seq_f;

					&print_fasta( $id, $pFasta_pads, $padded, $pads_length ) if ( $padded );
					&print_fasta( $id, $pFasta, $unpadded, $fasta_length )	if ( $unpadded );
				}
				last SWITCH; 
			}
		}
#================================= END SWITCH =================================
	}
	close( TMP );

	unlink( $tmp );
}




###############################################################################



sub print_fasta{
	my ( $name, $pHash, $filename, $length ) = @_; 
	my ( $i, $string );

	print $filename ">$name\n";

	for ( $i = 0; $i < $length; $i+=60){
		$string = substr( $$pHash{$name}, $i, 60 );
		print $filename "$string\n";
	}
}


1;
